/* Project name:
     ADC_on_LEDs (Demonstraion on usage of the ADC library for dsPIC)
 * Copyright:
     (c) mikroElektronika, 2011.
 * Revision History:
     20110117:
       - Initial release (TL);
 * Description:
     In this simple example, the analog input value is read on the channel 10,
     then the read value is converted to a string and sent through the UART1.
 * Test configuration:
     MCU:             dsPIC30F6014A
                      http://ww1.microchip.com/downloads/en/DeviceDoc/70143D.pdf
     Dev.Board:       BIGdsPIC6
                      http://www.mikroe.com/eng/products/view/483/bigdspic6-development-system/
     Oscillator:      XT-PLL8, 10.000MHz
     Ext. Modules:    None.
     SW:              mikroC PRO for dsPIC30/33 and PIC24 v4.60
                      http://www.mikroe.com/eng/products/view/231/mikroc-pro-for-dspic30-33-and-pic24/
 * NOTES:
     - On BIGdsPIC6 board, you can use the built-in potentiometers P3 and P4 to
       simulate analog input signal.
     - Turn ON PORTD LEDs at SW11. (board specific)
     - The user must make sure that appropriate pin is set as input.
 */

unsigned ADCresult;

void main() {

  TRISB = 0xFFFF;               // set PORTB as input - needed for ADC to work
  TRISD = 0x0000;               // set PORTD as output

  while (1) {
    ADCresult = ADC1_Read(10);  // get ADC value from 2nd channel
    LATD = ADCresult;           // display adc_rd[7..0]
  }
}