/* Project name:
     Led_Blinking (The simplest simple example)
 * Copyright:
     (c) mikroElektronika, 2011.
 * Revision History:
     20110117:
       - Initial release (TL);
 * Description:
     Simple "Hello world" example for the world of dsPIC MCUs;
 * Test configuration:
     MCU:             dsPIC30F6014A
                      http://ww1.microchip.com/downloads/en/DeviceDoc/70143D.pdf
     Dev.Board:       BIGdsPIC6
                      http://www.mikroe.com/eng/products/view/483/bigdspic6-development-system/
     Oscillator:      XT-PLL8, 10.000MHz
     Ext. Modules:    None.
     SW:              mikroC PRO for dsPIC30/33 and PIC24 v4.60
                      http://www.mikroe.com/eng/products/view/231/mikroc-pro-for-dspic30-33-and-pic24/
 * NOTES:
     - Turn ON port LEDs at SW11 (board specific).
 */

void main() {

  ADPCFG = 0xFFFF;       // Configure AN pins as digital I/O
  
  TRISA = 0;             // Initialize PORTA as output
  TRISB = 0;             // Initialize PORTB as output
  TRISC = 0;             // Initialize PORTC as output
  TRISD = 0;             // Initialize PORTD as output
  TRISF = 0;             // Initialize PORTF as output

  LATA = 0;              // Set PORTA to zero
  LATB = 0;              // Set PORTB to zero
  LATC = 0;              // Set PORTC to zero
  LATD = 0;              // Set PORTD to zero
  LATF = 0;              // Set PORTF to zero

  while(1) {
    LATA = ~LATA;        // Invert PORTA to value
    LATB = ~LATB;        // Invert PORTB to value
    LATC = ~LATC;        // Invert PORTC to value
    LATD = ~LATD;        // Invert PORTD to value
    LATF = ~LATF;        // Invert PORTF to value
    Delay_ms(1000);      // One second delay
  }
}