//EEPROM 24C02 read/write library


//--------------- Performs 24C02 Init
void EEPROM_24C02_Init() {
  I2C1_Init(100000);
}//~

//--------------- Writes data to 24C02 EEPROM - signle location
void EEPROM_24C02_WrSingle(unsigned short wAddr, unsigned short wData) {
    I2C1_Start();                 // issue I2C start signal
    I2C1_Write(0xA2);             // send byte via I2C  (command to 24cO2)
    I2C1_Write(wAddr);            // send byte (address of EEPROM location)
    I2C1_Write(wData);            // send data (data to be written)
    I2C1_Stop();
}//~

//--------------- Reads data from 24C02 EEPROM - single location (random)
unsigned short EEPROM_24C02_RdSingle(unsigned short rAddr) {
    unsigned short reslt;

    I2C1_Start();                 // issue I2C start signal
    I2C1_Write(0xA2);             // send byte via I2C  (device address + W)
    I2C1_Write(rAddr);            // send byte (data address)
    I2C1_Restart();               // issue I2C signal repeated start
    I2C1_Write(0xA3);             // send byte (device address + R)
    reslt = I2C1_Read(1);         // Read the data (NO acknowledge)
    while (!I2C1_Is_Idle())
      asm nop;                    // Wait for the read cycle to finish
    I2C1_Stop();
    return reslt;
}//~

//--------------- Reads data from 24C02 EEPROM - sequential read
void EEPROM_24C02_RdSeq(unsigned short rAddr,
                        unsigned char *rdData,
                        unsigned short rLen) {
  unsigned short i;
  // C doesn't keep the char[] array length information, so it's up to
  //   the programmer to take care not to exceed it!!!
  I2C1_Start();                // issue I2C start signal
  I2C1_Write(0xA2);               // send byte via I2C  (device address + W)
  I2C1_Write(rAddr);              // send byte (address of EEPROM location)
  I2C1_Restart();       // issue I2C signal repeated start
  I2C1_Write(0xA3);               // send byte (device address + R)
  i = 0;
  while (i < rLen) {
    rdData[i] = I2C1_Read(0);   // read data (YES acknowledge)
    Delay_ms(20);
    i++ ;
  }
  rdData[i] = I2C1_Read(1);     // last data is red WITH ack
  I2C1_Stop();
}//~









/*// EEPROM 24C02 read/write library


//--------------- Performs 24C02 Init
void EEPROM_24C02_Init() {
  I2C1_Init(100000);
}

//--------------- Writes data to 24C02 EEPROM - single location
void EEPROM_24C02_WrSingle(unsigned short wAddr, unsigned short wData) {
    I2C1_Start();                // issue I2C start signal
    I2C1_Write(0xA2);            // send byte via I2C  (command to 24cO2)
    I2C1_Write(wAddr);           // send byte (address of EEPROM location)
    I2C1_Write(wData);           // send data (data to be written)
    I2C1_Stop();
}

//--------------- Reads data from 24C02 EEPROM - single location (random)
unsigned short EEPROM_24C02_RdSingle(unsigned short rAddr) {
    unsigned short reslt;

    I2C1_Start();                // issue I2C start signal
    I2C1_Write(0xA2);            // send byte via I2C  (device address + W)
    I2C1_Write(rAddr);           // send byte (data address)
    I2C1_Restart();       // issue I2C signal repeated start
    I2C1_Write(0xA3);            // send byte (device address + R)
    reslt = I2C1_Read(0u);         // Read the data (NO acknowledge)
    while (!I2C1_Is_Idle())
      asm nop;                  // Wait for the read cycle to finish
    I2C1_Stop();
    return reslt;
}

//--------------- Reads data from 24C02 EEPROM - sequential read
void EEPROM_24C02_RdSeq(unsigned short rAddr,
                        unsigned char *rdData,
                        unsigned short rLen) {
  unsigned short i;
  I2C1_Start();               // issue I2C start signal
  I2C1_Write(0xA2);              // send byte via I2C  (device address + W)
  I2C1_Write(rAddr);             // send byte (address of EEPROM location)
  I2C1_Restart();      // issue I2C signal repeated start
  I2C1_Write(0xA3);              // send byte (device address + R)
  i = 0;
  while (i < rLen) {
    rdData[i] = I2C1_Read(1u);  // read data (acknowledge)
    Delay_ms(20);
    i++ ;
  }
  rdData[i] = I2C1_Read(0u);    // last data is read (no acknowledge)
  I2C1_Stop();
}*/